# -*- coding: utf-8 -*-
# by einfall, pclin & Sven_H for DreamOS

from Components.config import config, ConfigSelectionNumber, ConfigInteger, ConfigYesNo, ConfigIP, ConfigSelection, ConfigSubsection, NoSave, ConfigText
from Plugins.Plugin import PluginDescriptor

from hyperioncontrol import _, hyperionStart, hyperioncontrol_version

config.plugins.hyperioncontrol = ConfigSubsection()
config.plugins.hyperioncontrol.saturationGain = NoSave(ConfigSelectionNumber(0,500,1,default = 100))
config.plugins.hyperioncontrol.valueGain = NoSave(ConfigSelectionNumber(0,500,1,default = 100))
config.plugins.hyperioncontrol.saturationLGain = NoSave(ConfigSelectionNumber(0,100,1,default = 100))
config.plugins.hyperioncontrol.luminanceGain = NoSave(ConfigSelectionNumber(0,100,1,default = 100))
config.plugins.hyperioncontrol.luminanceMinimum = NoSave(ConfigSelectionNumber(0,50,1,default = 0))
config.plugins.hyperioncontrol.gammaRed = NoSave(ConfigSelectionNumber(0,500,1,default = 250))
config.plugins.hyperioncontrol.gammaGreen = NoSave(ConfigSelectionNumber(0,500,1,default = 250))
config.plugins.hyperioncontrol.gammaBlue = NoSave(ConfigSelectionNumber(0,500,1,default = 250))
config.plugins.hyperioncontrol.thresholdRed = NoSave(ConfigSelectionNumber(0,100,1,default = 0))
config.plugins.hyperioncontrol.thresholdGreen = NoSave(ConfigSelectionNumber(0,100,1,default = 0))
config.plugins.hyperioncontrol.thresholdBlue = NoSave(ConfigSelectionNumber(0,100,1,default = 0))
config.plugins.hyperioncontrol.temperatureRed = NoSave(ConfigSelectionNumber(0,255,1,default = 255))
config.plugins.hyperioncontrol.temperatureGreen = NoSave(ConfigSelectionNumber(0,255,1,default = 255))
config.plugins.hyperioncontrol.temperatureBlue = NoSave(ConfigSelectionNumber(0,255,1,default = 255))
config.plugins.hyperioncontrol.redAdjustRed = NoSave(ConfigSelectionNumber(255,255,1,default = 255))
config.plugins.hyperioncontrol.redAdjustGreen = NoSave(ConfigSelectionNumber(0,255,1,default = 0))
config.plugins.hyperioncontrol.redAdjustBlue = NoSave(ConfigSelectionNumber(0,255,1,default = 0))
config.plugins.hyperioncontrol.greenAdjustRed = NoSave(ConfigSelectionNumber(0,255,1,default = 0))
config.plugins.hyperioncontrol.greenAdjustGreen = NoSave(ConfigSelectionNumber(255,255,1,default = 255))
config.plugins.hyperioncontrol.greenAdjustBlue = NoSave(ConfigSelectionNumber(0,255,1,default = 0))
config.plugins.hyperioncontrol.blueAdjustRed = NoSave(ConfigSelectionNumber(0,255,1,default = 0))
config.plugins.hyperioncontrol.blueAdjustGreen = NoSave(ConfigSelectionNumber(0,255,1,default = 0))
config.plugins.hyperioncontrol.blueAdjustBlue = NoSave(ConfigSelectionNumber(255,255,1,default = 255))
config.plugins.hyperioncontrol.whitelevelRed = NoSave(ConfigSelectionNumber(0,100,1,default = 100))
config.plugins.hyperioncontrol.whitelevelGreen = NoSave(ConfigSelectionNumber(0,100,1,default = 100))
config.plugins.hyperioncontrol.whitelevelBlue = NoSave(ConfigSelectionNumber(0,100,1,default = 100))
config.plugins.hyperioncontrol.blacklevelRed = NoSave(ConfigSelectionNumber(0,50,1,default = 0))
config.plugins.hyperioncontrol.blacklevelGreen = NoSave(ConfigSelectionNumber(0,50,1,default = 0))
config.plugins.hyperioncontrol.blacklevelBlue = NoSave(ConfigSelectionNumber(0,50,1,default = 0))
config.plugins.hyperioncontrol.bbdEnable = NoSave(ConfigYesNo(default = True))
config.plugins.hyperioncontrol.bbdThreshold = NoSave(ConfigSelectionNumber(1,20,1,default = 4))
config.plugins.hyperioncontrol.framegrabberSize = NoSave(ConfigSelection(choices=[("160,160","160x160"),("320,320","320x320"),("384,216","384x216"),("640,640","640x640"),("720,576","720x576"),("720,720","720x720"),("1280,720","1280x720"),("1080,1080","1080x1080"),("1920,1080","1920x1080")], default = "160,160"))
config.plugins.hyperioncontrol.framegrabberFreq = NoSave(ConfigSelectionNumber(10,25,5,default = 10))
config.plugins.hyperioncontrol.webConfigEnable = NoSave(ConfigYesNo(default = True))
config.plugins.hyperioncontrol.webConfigPort   = NoSave(ConfigInteger(default = 8099, limits=(1, 65535) ))
config.plugins.hyperioncontrol.bootseqStart = NoSave(ConfigSelection(choices=[("color",_("Color")),("effect",_("Effect")),("off",_("off"))],default = "effect"))
config.plugins.hyperioncontrol.bootseqColor = NoSave(ConfigSelection(choices=[("#FFFFFF","")],default = "#FFFFFF"))
config.plugins.hyperioncontrol.bootseqEffect = NoSave(ConfigSelection(choices=[("Rainbow swirl fast","Rainbow swirl fast")],default = "Rainbow swirl fast"))
config.plugins.hyperioncontrol.bootseqDuration = NoSave(ConfigSelectionNumber(0,10000,500,default = 3000))

config.plugins.hyperioncontrol.deviceType = ConfigSelection(choices=[("udpraw","UDPRaw"),("sedu","Sedulight"),("adalight","Adalight"),("atmo","Atmolight"),("philipshue","PhilipsHue")], default = "udpraw")
config.plugins.hyperioncontrol.configName = ConfigText("HyperionConfig", False)
config.plugins.hyperioncontrol.outputIP = ConfigIP(default = [192, 168, 178, 24])
config.plugins.hyperioncontrol.delayafterconnect = ConfigSelectionNumber(0,20,1,default = 0)
config.plugins.hyperioncontrol.colorOrder = ConfigSelection(choices=[("rgb","RGB"), ("bgr","BGR"), ("rbg","RBG"), ("brg","BRG"), ("grb","GRB"), ("gbr","GBR")], default = "brg")
config.plugins.hyperioncontrol.baudrate = ConfigSelectionNumber(50000,2000000,25000,default = 250000)
config.plugins.hyperioncontrol.lastpicpath = ConfigText("/", False)
config.plugins.hyperioncontrol.ledDirection = ConfigSelection(choices=[("1",_("clockwise")), ("2",_("counterclockwise"))], default = "1")
config.plugins.hyperioncontrol.ledBegin = ConfigSelection(choices=[("0",_("none")),("1",_("bottom middle")), ("2",_("right bottom")), ("3",_("right top")), ("4",_("left top")), ("5",_("left bottom"))], default = "0")
config.plugins.hyperioncontrol.ledTop = ConfigSelectionNumber(0,300,1,default = 0)
config.plugins.hyperioncontrol.ledRight = ConfigSelectionNumber(0,200,1,default = 0)
config.plugins.hyperioncontrol.ledLeft = ConfigSelectionNumber(0,200,1,default = 0)
config.plugins.hyperioncontrol.ledBottomGap = ConfigSelectionNumber(0,100,1,default = 0)
config.plugins.hyperioncontrol.ledCornerTopLeft = ConfigYesNo(default = False)
config.plugins.hyperioncontrol.ledCornerTopRight = ConfigYesNo(default = False)
config.plugins.hyperioncontrol.ledCornerBottomLeft = ConfigYesNo(default = False)
config.plugins.hyperioncontrol.ledCornerBottomRight = ConfigYesNo(default = False)
config.plugins.hyperioncontrol.hPicDeep = ConfigSelectionNumber(1,99,1,default = 8)
config.plugins.hyperioncontrol.vPicDeep = ConfigSelectionNumber(1,99,1,default = 5)
config.plugins.hyperioncontrol.hPicDist = ConfigSelectionNumber(0,50,1,default = 0)
config.plugins.hyperioncontrol.vPicDist = ConfigSelectionNumber(0,50,1,default = 0)
config.plugins.hyperioncontrol.PicOverlap = ConfigSelectionNumber(0,100,1,default = 0)

def main(session, **kwargs):
	session.open(hyperionStart)

def Plugins(path,**kwargs):
	return [PluginDescriptor(
		name =_("Hyperion Control"), 
		description = _("Control Your LEDs (v%s)") % hyperioncontrol_version, 
		where = PluginDescriptor.WHERE_PLUGINMENU,icon="hyperioncontrol.png",
		fnc = main
		),
	PluginDescriptor(name=_("Hyperion Control"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)]
